Tonyu.klass.define({
  fullName: 'user.CostMatrix',
  shortName: 'CostMatrix',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Matrix,
  includes: [],
  methods: {
    main :function _trc_CostMatrix_main() {
      "use strict";
      var _this=this;
      
    },
    fiber$main :function _trc_CostMatrix_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.retVal=_this;return;
    },
    searchRoute :function _trc_CostMatrix_searchRoute(dst) {
      "use strict";
      var _this=this;
      var res;
      var p;
      
      //$LASTPOS=1000041;//user.CostMatrix:41
      res = [];
      
      //$LASTPOS=1000057;//user.CostMatrix:57
      //$LASTPOS=1000062;//user.CostMatrix:62
      p = _this.get(dst.x,dst.y);
      for (; p ; p=p.src) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=1000106;//user.CostMatrix:106
          res.unshift(p);
        }
      }
      return res;
    },
    fiber$searchRoute :function _trc_CostMatrix_f_searchRoute(_thread,dst) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var res;
      var p;
      
      //$LASTPOS=1000041;//user.CostMatrix:41
      res = [];
      
      
      _thread.enter(function _trc_CostMatrix_ent_searchRoute(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=1000057;//user.CostMatrix:57
            //$LASTPOS=1000062;//user.CostMatrix:62
            _this.fiber$get(_thread, dst.x, dst.y);
            __pc=2;return;
          case 2:
            p=_thread.retVal;
            
          case 1:
            if (!(p)) { __pc=4     ; break; }
            {
              //$LASTPOS=1000106;//user.CostMatrix:106
              res.unshift(p);
            }
          case 3     :
            p=p.src;
            __pc=1;break;
          case 4     :
            
            _thread.exit(res);return;
            _thread.exit(_this);return;
          }
        }
      });
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"searchRoute":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Main_main() {
      "use strict";
      var _this=this;
      var _it_3;
      var _it_4;
      
      //$LASTPOS=2000000;//user.Main:0
      Tonyu.globals.$Screen.setBGColor("green");
      //$LASTPOS=2000029;//user.Main:29
      Tonyu.globals.$Screen.resize(20*32,10*32);
      //$LASTPOS=2000058;//user.Main:58
      _this.rangePanel=new Tonyu.classes.kernel.Panel;
      //$LASTPOS=2000080;//user.Main:80
      Tonyu.globals.$mat=new Tonyu.classes.kernel.Matrix;
      //$LASTPOS=2000097;//user.Main:97
      Tonyu.globals.$mat.fill(0,0,20,10,{});
      //$LASTPOS=2000160;//user.Main:160
      //$LASTPOS=2000165;//user.Main:165
      _this.i=0;for (; _this.i<10 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000185;//user.Main:185
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto,x: 4,y: _this.i});
          //$LASTPOS=2000220;//user.Main:220
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+12,x: 15,y: _this.i,rotation: 180});
        }
      }
      //$LASTPOS=2000272;//user.Main:272
      //$LASTPOS=2000277;//user.Main:277
      _this.i=0;for (; _this.i<3 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000296;//user.Main:296
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+3,x: 0,y: _this.i});
          //$LASTPOS=2000332;//user.Main:332
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+9,x: 0,y: _this.i+5});
          //$LASTPOS=2000370;//user.Main:370
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+3+12,x: 19,y: _this.i,rotation: 180});
          //$LASTPOS=2000423;//user.Main:423
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+9+12,x: 19,y: _this.i+5,rotation: 180});
        }
      }
      //$LASTPOS=2000476;//user.Main:476
      //$LASTPOS=2000481;//user.Main:481
      _this.i=0;for (; _this.i<2 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000500;//user.Main:500
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+7,x: 1,y: _this.i});
          //$LASTPOS=2000536;//user.Main:536
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+7+12,x: 18,y: _this.i,rotation: 180});
        }
      }
      //$LASTPOS=2000587;//user.Main:587
      //$LASTPOS=2000592;//user.Main:592
      _this.i=0;for (; _this.i<2 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000611;//user.Main:611
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+10,x: 1,y: _this.i+7});
          //$LASTPOS=2000650;//user.Main:650
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+10+12,x: 18,y: _this.i+7,rotation: 180});
        }
      }
      //$LASTPOS=2000704;//user.Main:704
      //$LASTPOS=2000709;//user.Main:709
      _this.i=0;for (; _this.i<2 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000728;//user.Main:728
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+1,x: 1,y: _this.i+3});
          //$LASTPOS=2000766;//user.Main:766
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+1+12,x: 18,y: _this.i+3,rotation: 180});
        }
      }
      //$LASTPOS=2000819;//user.Main:819
      new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+11,x: 2,y: 0});
      //$LASTPOS=2000852;//user.Main:852
      new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+11,x: 2,y: 9});
      //$LASTPOS=2000885;//user.Main:885
      new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+11+12,x: 17,y: 0,rotation: 180});
      //$LASTPOS=2000935;//user.Main:935
      new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+11+12,x: 17,y: 9,rotation: 180});
      //$LASTPOS=2000986;//user.Main:986
      _it_3=Tonyu.iterator([Tonyu.globals.$pat_eto+6,Tonyu.globals.$pat_eto+5,Tonyu.globals.$pat_eto+2,Tonyu.globals.$pat_eto+4,Tonyu.globals.$pat_eto+8],2);
      while(_it_3.next()) {
        _this.i=_it_3[0];
        _this.pp=_it_3[1];
        
        //$LASTPOS=2001063;//user.Main:1063
        new Tonyu.classes.user.Unit({p: _this.pp,x: 3,y: _this.i});
        //$LASTPOS=2001091;//user.Main:1091
        new Tonyu.classes.user.Unit({p: _this.pp+12,x: 16,y: _this.i,rotation: 180});
        
      }
      //$LASTPOS=2001134;//user.Main:1134
      new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+11,x: 2,y: 0});
      //$LASTPOS=2001167;//user.Main:1167
      //$LASTPOS=2001172;//user.Main:1172
      _this.i=0;for (; _this.i<=20 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2001193;//user.Main:1193
          Tonyu.globals.$panel.fillStyle="white";
          //$LASTPOS=2001223;//user.Main:1223
          Tonyu.globals.$panel.fillRect(_this.i*32,0,1,32*10);
        }
      }
      //$LASTPOS=2001261;//user.Main:1261
      //$LASTPOS=2001266;//user.Main:1266
      _this.i=0;for (; _this.i<=10 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2001287;//user.Main:1287
          Tonyu.globals.$panel.fillStyle="white";
          //$LASTPOS=2001317;//user.Main:1317
          Tonyu.globals.$panel.fillRect(0,_this.i*32,32*20,1);
        }
      }
      //$LASTPOS=2001410;//user.Main:1410
      _this.alpha=128;
      //$LASTPOS=2001421;//user.Main:1421
      _this.fillStyle="white";
      //$LASTPOS=2001440;//user.Main:1440
      _this.radius=16;
      //$LASTPOS=2001451;//user.Main:1451
      while (true) {
        Tonyu.checkLoop();
        //$LASTPOS=2001469;//user.Main:1469
        _this.gx=_this.floor(Tonyu.globals.$mouseX/32);
        //$LASTPOS=2001495;//user.Main:1495
        _this.gy=_this.floor(Tonyu.globals.$mouseY/32);
        //$LASTPOS=2001521;//user.Main:1521
        _this.x=_this.gx*32+16;
        //$LASTPOS=2001537;//user.Main:1537
        _this.y=_this.gy*32+16;
        //$LASTPOS=2001553;//user.Main:1553
        if (_this.u) {
          //$LASTPOS=2001570;//user.Main:1570
          _this.p=4;
          //$LASTPOS=2001583;//user.Main:1583
          if (Tonyu.globals.$touches[0].touched==1) {
            //$LASTPOS=2001625;//user.Main:1625
            _this.rangePanel.clearRect();
            //$LASTPOS=2001661;//user.Main:1661
            _this.u.moveTo(_this.cm,_this.gx,_this.gy);
            //$LASTPOS=2001693;//user.Main:1693
            while (_this.u.moving) {
              Tonyu.checkLoop();
              //$LASTPOS=2001709;//user.Main:1709
              _this.update();
            }
            //$LASTPOS=2001731;//user.Main:1731
            _this.u=null;
            //$LASTPOS=2001751;//user.Main:1751
            _this.p=1;
            
          }
          
        } else {
          //$LASTPOS=2001787;//user.Main:1787
          _this.p=1;
          //$LASTPOS=2001800;//user.Main:1800
          if (Tonyu.globals.$touches[0].touched==1) {
            //$LASTPOS=2001842;//user.Main:1842
            _this.u=_this.find(_this.gx,_this.gy);
            //$LASTPOS=2001869;//user.Main:1869
            if (_this.u) {
              //$LASTPOS=2001894;//user.Main:1894
              _this.cm=new Tonyu.classes.user.MatrixSearcher(Tonyu.globals.$mat,{moveCost: _this.u.moveCost.bind(_this.u)}).searchCost({x: _this.u.x,y: _this.u.y,max: _this.u.status.spd});
              //$LASTPOS=2002050;//user.Main:2050
              _this.rangePanel.clearRect(0,0,Tonyu.globals.$screenWidth,Tonyu.globals.$screenHeight);
              //$LASTPOS=2002120;//user.Main:2120
              _this.rangePanel.alpha=128;
              //$LASTPOS=2002158;//user.Main:2158
              _it_4=Tonyu.iterator(_this.cm.keysIterator(),3);
              while(_it_4.next()) {
                _this.xx=_it_4[0];
                _this.yy=_it_4[1];
                _this.c=_it_4[2];
                
                //$LASTPOS=2002219;//user.Main:2219
                _this.rangePanel.fillRect(_this.xx*32,_this.yy*32,32,32);
                
              }
              
            }
            
          }
          
        }
        //$LASTPOS=2002311;//user.Main:2311
        _this.update();
        
      }
    },
    fiber$main :function _trc_Main_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var _it_3;
      var _it_4;
      
      //$LASTPOS=2000000;//user.Main:0
      Tonyu.globals.$Screen.setBGColor("green");
      //$LASTPOS=2000029;//user.Main:29
      Tonyu.globals.$Screen.resize(20*32,10*32);
      //$LASTPOS=2000058;//user.Main:58
      _this.rangePanel=new Tonyu.classes.kernel.Panel;
      //$LASTPOS=2000080;//user.Main:80
      Tonyu.globals.$mat=new Tonyu.classes.kernel.Matrix;
      //$LASTPOS=2000097;//user.Main:97
      Tonyu.globals.$mat.fill(0,0,20,10,{});
      //$LASTPOS=2000160;//user.Main:160
      //$LASTPOS=2000165;//user.Main:165
      _this.i=0;for (; _this.i<10 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000185;//user.Main:185
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto,x: 4,y: _this.i});
          //$LASTPOS=2000220;//user.Main:220
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+12,x: 15,y: _this.i,rotation: 180});
        }
      }
      //$LASTPOS=2000272;//user.Main:272
      //$LASTPOS=2000277;//user.Main:277
      _this.i=0;for (; _this.i<3 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000296;//user.Main:296
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+3,x: 0,y: _this.i});
          //$LASTPOS=2000332;//user.Main:332
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+9,x: 0,y: _this.i+5});
          //$LASTPOS=2000370;//user.Main:370
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+3+12,x: 19,y: _this.i,rotation: 180});
          //$LASTPOS=2000423;//user.Main:423
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+9+12,x: 19,y: _this.i+5,rotation: 180});
        }
      }
      //$LASTPOS=2000476;//user.Main:476
      //$LASTPOS=2000481;//user.Main:481
      _this.i=0;for (; _this.i<2 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000500;//user.Main:500
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+7,x: 1,y: _this.i});
          //$LASTPOS=2000536;//user.Main:536
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+7+12,x: 18,y: _this.i,rotation: 180});
        }
      }
      //$LASTPOS=2000587;//user.Main:587
      //$LASTPOS=2000592;//user.Main:592
      _this.i=0;for (; _this.i<2 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000611;//user.Main:611
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+10,x: 1,y: _this.i+7});
          //$LASTPOS=2000650;//user.Main:650
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+10+12,x: 18,y: _this.i+7,rotation: 180});
        }
      }
      //$LASTPOS=2000704;//user.Main:704
      //$LASTPOS=2000709;//user.Main:709
      _this.i=0;for (; _this.i<2 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2000728;//user.Main:728
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+1,x: 1,y: _this.i+3});
          //$LASTPOS=2000766;//user.Main:766
          new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+1+12,x: 18,y: _this.i+3,rotation: 180});
        }
      }
      //$LASTPOS=2000819;//user.Main:819
      new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+11,x: 2,y: 0});
      //$LASTPOS=2000852;//user.Main:852
      new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+11,x: 2,y: 9});
      //$LASTPOS=2000885;//user.Main:885
      new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+11+12,x: 17,y: 0,rotation: 180});
      //$LASTPOS=2000935;//user.Main:935
      new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+11+12,x: 17,y: 9,rotation: 180});
      //$LASTPOS=2000986;//user.Main:986
      _it_3=Tonyu.iterator([Tonyu.globals.$pat_eto+6,Tonyu.globals.$pat_eto+5,Tonyu.globals.$pat_eto+2,Tonyu.globals.$pat_eto+4,Tonyu.globals.$pat_eto+8],2);
      while(_it_3.next()) {
        _this.i=_it_3[0];
        _this.pp=_it_3[1];
        
        //$LASTPOS=2001063;//user.Main:1063
        new Tonyu.classes.user.Unit({p: _this.pp,x: 3,y: _this.i});
        //$LASTPOS=2001091;//user.Main:1091
        new Tonyu.classes.user.Unit({p: _this.pp+12,x: 16,y: _this.i,rotation: 180});
        
      }
      //$LASTPOS=2001134;//user.Main:1134
      new Tonyu.classes.user.Unit({p: Tonyu.globals.$pat_eto+11,x: 2,y: 0});
      //$LASTPOS=2001167;//user.Main:1167
      //$LASTPOS=2001172;//user.Main:1172
      _this.i=0;for (; _this.i<=20 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2001193;//user.Main:1193
          Tonyu.globals.$panel.fillStyle="white";
          //$LASTPOS=2001223;//user.Main:1223
          Tonyu.globals.$panel.fillRect(_this.i*32,0,1,32*10);
        }
      }
      //$LASTPOS=2001261;//user.Main:1261
      //$LASTPOS=2001266;//user.Main:1266
      _this.i=0;for (; _this.i<=10 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=2001287;//user.Main:1287
          Tonyu.globals.$panel.fillStyle="white";
          //$LASTPOS=2001317;//user.Main:1317
          Tonyu.globals.$panel.fillRect(0,_this.i*32,32*20,1);
        }
      }
      //$LASTPOS=2001410;//user.Main:1410
      _this.alpha=128;
      //$LASTPOS=2001421;//user.Main:1421
      _this.fillStyle="white";
      //$LASTPOS=2001440;//user.Main:1440
      _this.radius=16;
      
      _thread.enter(function _trc_Main_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=2001451;//user.Main:1451
          case 1:
            //$LASTPOS=2001469;//user.Main:1469
            _this.gx=_this.floor(Tonyu.globals.$mouseX/32);
            //$LASTPOS=2001495;//user.Main:1495
            _this.gy=_this.floor(Tonyu.globals.$mouseY/32);
            //$LASTPOS=2001521;//user.Main:1521
            _this.x=_this.gx*32+16;
            //$LASTPOS=2001537;//user.Main:1537
            _this.y=_this.gy*32+16;
            //$LASTPOS=2001553;//user.Main:1553
            if (!(_this.u)) { __pc=6     ; break; }
            //$LASTPOS=2001570;//user.Main:1570
            _this.p=4;
            //$LASTPOS=2001583;//user.Main:1583
            if (!(Tonyu.globals.$touches[0].touched==1)) { __pc=5     ; break; }
            //$LASTPOS=2001625;//user.Main:1625
            _this.rangePanel.clearRect();
            //$LASTPOS=2001661;//user.Main:1661
            _this.u.moveTo(_this.cm,_this.gx,_this.gy);
            //$LASTPOS=2001693;//user.Main:1693
          case 2:
            if (!(_this.u.moving)) { __pc=4     ; break; }
            //$LASTPOS=2001709;//user.Main:1709
            _this.fiber$update(_thread);
            __pc=3;return;
          case 3:
            
            __pc=2;break;
          case 4     :
            
            //$LASTPOS=2001731;//user.Main:1731
            _this.u=null;
            //$LASTPOS=2001751;//user.Main:1751
            _this.p=1;
          case 5     :
            
            __pc=9     ;break;
          case 6     :
            //$LASTPOS=2001787;//user.Main:1787
            _this.p=1;
            //$LASTPOS=2001800;//user.Main:1800
            if (!(Tonyu.globals.$touches[0].touched==1)) { __pc=8     ; break; }
            //$LASTPOS=2001842;//user.Main:1842
            _this.fiber$find(_thread, _this.gx, _this.gy);
            __pc=7;return;
          case 7:
            _this.u=_thread.retVal;
            
            //$LASTPOS=2001869;//user.Main:1869
            if (_this.u) {
              //$LASTPOS=2001894;//user.Main:1894
              _this.cm=new Tonyu.classes.user.MatrixSearcher(Tonyu.globals.$mat,{moveCost: _this.u.moveCost.bind(_this.u)}).searchCost({x: _this.u.x,y: _this.u.y,max: _this.u.status.spd});
              //$LASTPOS=2002050;//user.Main:2050
              _this.rangePanel.clearRect(0,0,Tonyu.globals.$screenWidth,Tonyu.globals.$screenHeight);
              //$LASTPOS=2002120;//user.Main:2120
              _this.rangePanel.alpha=128;
              //$LASTPOS=2002158;//user.Main:2158
              _it_4=Tonyu.iterator(_this.cm.keysIterator(),3);
              while(_it_4.next()) {
                _this.xx=_it_4[0];
                _this.yy=_it_4[1];
                _this.c=_it_4[2];
                
                //$LASTPOS=2002219;//user.Main:2219
                _this.rangePanel.fillRect(_this.xx*32,_this.yy*32,32,32);
                
              }
              
            }
          case 8     :
            
          case 9     :
            
            //$LASTPOS=2002311;//user.Main:2311
            _this.fiber$update(_thread);
            __pc=10;return;
          case 10:
            
            __pc=1;break;
          case 11    :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    find :function _trc_Main_find(gx,gy) {
      "use strict";
      var _this=this;
      
      return _this.all(Tonyu.classes.user.Unit).find((function anonymous_2370(u) {
        
        return u.x==gx&&u.y==gy;
      }))[0];
    },
    fiber$find :function _trc_Main_f_find(_thread,gx,gy) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      _thread.retVal=_this.all(Tonyu.classes.user.Unit).find((function anonymous_2370(u) {
        
        return u.x==gx&&u.y==gy;
      }))[0];return;
      
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"find":{"nowait":false}},"fields":{"rangePanel":{},"i":{},"pp":{},"gx":{},"gy":{},"u":{},"cm":{},"xx":{},"yy":{},"c":{}}}
});
Tonyu.klass.define({
  fullName: 'user.MatrixSearcher',
  shortName: 'MatrixSearcher',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.TObject,
  includes: [],
  methods: {
    main :function _trc_MatrixSearcher_main() {
      "use strict";
      var _this=this;
      
    },
    fiber$main :function _trc_MatrixSearcher_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      
      _thread.retVal=_this;return;
    },
    initialize :function _trc_MatrixSearcher_initialize(m,options) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=3000039;//user.MatrixSearcher:39
      _this.m=m;
      //$LASTPOS=3000053;//user.MatrixSearcher:53
      _this.options=options||{};
    },
    searchRoute :function _trc_MatrixSearcher_searchRoute(src,dst,options) {
      "use strict";
      var _this=this;
      var cm;
      
      //$LASTPOS=3000117;//user.MatrixSearcher:117
      cm = _this.searchCost(src,{dst: dst});
      
      return cm.searchRoute(dst);
    },
    fiber$searchRoute :function _trc_MatrixSearcher_f_searchRoute(_thread,src,dst,options) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var cm;
      
      
      _thread.enter(function _trc_MatrixSearcher_ent_searchRoute(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=3000117;//user.MatrixSearcher:117
            _this.fiber$searchCost(_thread, src, {dst: dst});
            __pc=1;return;
          case 1:
            cm=_thread.retVal;
            
            _thread.exit(cm.searchRoute(dst));return;
            _thread.exit(_this);return;
          }
        }
      });
    },
    searchCost :function _trc_MatrixSearcher_searchCost(src,options) {
      "use strict";
      var _this=this;
      var cm;
      var cont;
      var dobrk;
      var x;
      var y;
      var c;
      var _it_9;
      var ns;
      var n;
      var _it_10;
      function setCM(x,y,cost,src) {
        var d;
        
        //$LASTPOS=3000931;//user.MatrixSearcher:931
        if (options.max&&cost>options.max) {
          return false;
        }
        //$LASTPOS=3000990;//user.MatrixSearcher:990
        if (! cm.exists(x,y)) {
          //$LASTPOS=3001025;//user.MatrixSearcher:1025
          cm.set(x,y,{x: x,y: y,value: _this.m.get(x,y),cost: cost,src: src});
          return true;
          
        } else {
          //$LASTPOS=3001124;//user.MatrixSearcher:1124
          d = cm.get(x,y);
          
          //$LASTPOS=3001155;//user.MatrixSearcher:1155
          if (cost<d.cost) {
            //$LASTPOS=3001190;//user.MatrixSearcher:1190
            d.cost=cost;
            //$LASTPOS=3001219;//user.MatrixSearcher:1219
            d.src=src;
            return true;
            
          }
          
        }
      }
      //$LASTPOS=3000238;//user.MatrixSearcher:238
      options=options||{max: typeof  (src.max)==="number"?src.max:null};
      //$LASTPOS=3000320;//user.MatrixSearcher:320
      cm = new Tonyu.classes.user.CostMatrix;
      
      //$LASTPOS=3000347;//user.MatrixSearcher:347
      setCM(src.x,src.y,0);
      
      //$LASTPOS=3000393;//user.MatrixSearcher:393
      do {
        Tonyu.checkLoop();
        //$LASTPOS=3000406;//user.MatrixSearcher:406
        cont=false;
        //$LASTPOS=3000426;//user.MatrixSearcher:426
        _it_9=Tonyu.iterator(cm.keysIterator(),3);
        while(_it_9.next()) {
          x=_it_9[0];
          y=_it_9[1];
          c=_it_9[2];
          
          //$LASTPOS=3000477;//user.MatrixSearcher:477
          ns = _this.movableNeighbors(c);
          
          //$LASTPOS=3000517;//user.MatrixSearcher:517
          _it_10=Tonyu.iterator(ns,1);
          while(_it_10.next()) {
            n=_it_10[0];
            
            //$LASTPOS=3000599;//user.MatrixSearcher:599
            if (setCM(n.x,n.y,c.cost+n.cost,c)) {
              //$LASTPOS=3000657;//user.MatrixSearcher:657
              cont=true;
              //$LASTPOS=3000688;//user.MatrixSearcher:688
              if (options.dst&&n.x===options.dst.x&&n.y===options.dst.y) {
                //$LASTPOS=3000777;//user.MatrixSearcher:777
                dobrk=true;
                
              }
              
            }
            
          }
          
        }
        
      } while (cont&&! dobrk);
      
      return cm;
      
    },
    fiber$searchCost :function _trc_MatrixSearcher_f_searchCost(_thread,src,options) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var cm;
      var cont;
      var dobrk;
      var x;
      var y;
      var c;
      var _it_9;
      var ns;
      var n;
      var _it_10;
      function setCM(x,y,cost,src) {
        var d;
        
        //$LASTPOS=3000931;//user.MatrixSearcher:931
        if (options.max&&cost>options.max) {
          return false;
        }
        //$LASTPOS=3000990;//user.MatrixSearcher:990
        if (! cm.exists(x,y)) {
          //$LASTPOS=3001025;//user.MatrixSearcher:1025
          cm.set(x,y,{x: x,y: y,value: _this.m.get(x,y),cost: cost,src: src});
          return true;
          
        } else {
          //$LASTPOS=3001124;//user.MatrixSearcher:1124
          d = cm.get(x,y);
          
          //$LASTPOS=3001155;//user.MatrixSearcher:1155
          if (cost<d.cost) {
            //$LASTPOS=3001190;//user.MatrixSearcher:1190
            d.cost=cost;
            //$LASTPOS=3001219;//user.MatrixSearcher:1219
            d.src=src;
            return true;
            
          }
          
        }
      }
      //$LASTPOS=3000238;//user.MatrixSearcher:238
      options=options||{max: typeof  (src.max)==="number"?src.max:null};
      //$LASTPOS=3000320;//user.MatrixSearcher:320
      cm = new Tonyu.classes.user.CostMatrix;
      
      //$LASTPOS=3000347;//user.MatrixSearcher:347
      setCM(src.x,src.y,0);
      
      
      _thread.enter(function _trc_MatrixSearcher_ent_searchCost(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=3000393;//user.MatrixSearcher:393
          case 1:
            //$LASTPOS=3000406;//user.MatrixSearcher:406
            cont=false;
            //$LASTPOS=3000426;//user.MatrixSearcher:426
            _it_9=Tonyu.iterator(cm.keysIterator(),3);
          case 2:
            if (!(_it_9.next())) { __pc=4     ; break; }
            x=_it_9[0];
            y=_it_9[1];
            c=_it_9[2];
            
            //$LASTPOS=3000477;//user.MatrixSearcher:477
            _this.fiber$movableNeighbors(_thread, c);
            __pc=3;return;
          case 3:
            ns=_thread.retVal;
            
            //$LASTPOS=3000517;//user.MatrixSearcher:517
            _it_10=Tonyu.iterator(ns,1);
            while(_it_10.next()) {
              n=_it_10[0];
              
              //$LASTPOS=3000599;//user.MatrixSearcher:599
              if (setCM(n.x,n.y,c.cost+n.cost,c)) {
                //$LASTPOS=3000657;//user.MatrixSearcher:657
                cont=true;
                //$LASTPOS=3000688;//user.MatrixSearcher:688
                if (options.dst&&n.x===options.dst.x&&n.y===options.dst.y) {
                  //$LASTPOS=3000777;//user.MatrixSearcher:777
                  dobrk=true;
                  
                }
                
              }
              
            }
            __pc=2;break;
          case 4     :
            
          case 5     :
            if (cont&&! dobrk) { __pc=1; break; }
          case 6     :
            
            _thread.exit(cm);return;
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    movableNeighbors :function _trc_MatrixSearcher_movableNeighbors(src) {
      "use strict";
      var _this=this;
      var res;
      var dst;
      var _it_27;
      
      //$LASTPOS=3001354;//user.MatrixSearcher:1354
      if (_this.options.movableNeighbors) {
        return _this.options.movableNeighbors.apply(_this,arguments);
        
      }
      //$LASTPOS=3001459;//user.MatrixSearcher:1459
      res = [];
      
      //$LASTPOS=3001475;//user.MatrixSearcher:1475
      _it_27=Tonyu.iterator(_this.neighbors(src,_this.options),1);
      while(_it_27.next()) {
        dst=_it_27[0];
        
        //$LASTPOS=3001573;//user.MatrixSearcher:1573
        dst.cost=_this.moveCost(dst,src);
        //$LASTPOS=3001609;//user.MatrixSearcher:1609
        dst.src=src;
        //$LASTPOS=3001630;//user.MatrixSearcher:1630
        if (dst.cost) {
          //$LASTPOS=3001644;//user.MatrixSearcher:1644
          res.push(dst);
        }
        
      }
      return res;
    },
    fiber$movableNeighbors :function _trc_MatrixSearcher_f_movableNeighbors(_thread,src) {
      "use strict";
      var _this=this;
      var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var res;
      var dst;
      var _it_27;
      
      //$LASTPOS=3001354;//user.MatrixSearcher:1354
      if (_this.options.movableNeighbors) {
        _thread.retVal=_this.options.movableNeighbors.apply(_this,_arguments);return;
        
        
      }
      //$LASTPOS=3001459;//user.MatrixSearcher:1459
      res = [];
      
      
      _thread.enter(function _trc_MatrixSearcher_ent_movableNeighbors(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=3001475;//user.MatrixSearcher:1475
            _it_27=Tonyu.iterator(_this.neighbors(src,_this.options),1);
          case 1:
            if (!(_it_27.next())) { __pc=3     ; break; }
            dst=_it_27[0];
            
            //$LASTPOS=3001573;//user.MatrixSearcher:1573
            _this.fiber$moveCost(_thread, dst, src);
            __pc=2;return;
          case 2:
            dst.cost=_thread.retVal;
            
            //$LASTPOS=3001609;//user.MatrixSearcher:1609
            dst.src=src;
            //$LASTPOS=3001630;//user.MatrixSearcher:1630
            if (dst.cost) {
              //$LASTPOS=3001644;//user.MatrixSearcher:1644
              res.push(dst);
            }
            __pc=1;break;
          case 3     :
            
            _thread.exit(res);return;
            _thread.exit(_this);return;
          }
        }
      });
    },
    moveCost :function _trc_MatrixSearcher_moveCost(dst,src) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=3001799;//user.MatrixSearcher:1799
      if (_this.options.moveCost) {
        return _this.options.moveCost.apply(_this,arguments);
        
      }
      //$LASTPOS=3001888;//user.MatrixSearcher:1888
      if (dst.value===undefined) {
        return false;
      }
      return 1;
    },
    fiber$moveCost :function _trc_MatrixSearcher_f_moveCost(_thread,dst,src) {
      "use strict";
      var _this=this;
      var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=3001799;//user.MatrixSearcher:1799
      if (_this.options.moveCost) {
        _thread.retVal=_this.options.moveCost.apply(_this,_arguments);return;
        
        
      }
      //$LASTPOS=3001888;//user.MatrixSearcher:1888
      if (dst.value===undefined) {
        _thread.retVal=false;return;
        
      }
      _thread.retVal=1;return;
      
      
      _thread.retVal=_this;return;
    },
    neighbors :function _trc_MatrixSearcher_neighbors(src,options) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=3001975;//user.MatrixSearcher:1975
      if (options.neighbors) {
        return options.neighbors.apply(_this,arguments);
        
      }
      return _this.m.neighbors(src.x,src.y,options);
    },
    fiber$neighbors :function _trc_MatrixSearcher_f_neighbors(_thread,src,options) {
      "use strict";
      var _this=this;
      var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=3001975;//user.MatrixSearcher:1975
      if (options.neighbors) {
        _thread.retVal=options.neighbors.apply(_this,_arguments);return;
        
        
      }
      _thread.retVal=_this.m.neighbors(src.x,src.y,options);return;
      
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"searchRoute":{"nowait":false},"searchCost":{"nowait":false},"movableNeighbors":{"nowait":false},"moveCost":{"nowait":false},"neighbors":{"nowait":false}},"fields":{"m":{},"options":{}}}
});
Tonyu.klass.define({
  fullName: 'user.SearchTest',
  shortName: 'SearchTest',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_SearchTest_main() {
      "use strict";
      var _this=this;
      var _it_31;
      var _it_32;
      
      //$LASTPOS=4000042;//user.SearchTest:42
      _this.m=new Tonyu.classes.kernel.Matrix;
      //$LASTPOS=4000056;//user.SearchTest:56
      _this.m.fill(0,0,10,10,1);
      //$LASTPOS=4000077;//user.SearchTest:77
      //$LASTPOS=4000081;//user.SearchTest:81
      _this.i=0;for (; _this.i<30 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=4000101;//user.SearchTest:101
          _this.m.set(_this.rnd(10),_this.rnd(10),0);
        }
      }
      //$LASTPOS=4000129;//user.SearchTest:129
      _this.m.set(9,9,1);
      //$LASTPOS=4000143;//user.SearchTest:143
      _this.m.set(0,0,1);
      //$LASTPOS=4000157;//user.SearchTest:157
      _this.s=new Tonyu.classes.user.MatrixSearcher(_this.m,{moveCost: (function anonymous_197(dst,src) {
        
        return dst.value;
      })});
      //$LASTPOS=4000411;//user.SearchTest:411
      "toste";
      //$LASTPOS=4000421;//user.SearchTest:421
      _this.cm=_this.s.searchCost({x: 0,y: 0});
      //$LASTPOS=4000449;//user.SearchTest:449
      Tonyu.globals.$panel.fillStyle="white";
      //$LASTPOS=4000488;//user.SearchTest:488
      _it_31=Tonyu.iterator(_this.cm.keysIterator(),3);
      while(_it_31.next()) {
        _this.x=_it_31[0];
        _this.y=_it_31[1];
        _this.c=_it_31[2];
        
        //$LASTPOS=4000568;//user.SearchTest:568
        Tonyu.globals.$panel.fillText(_this.c.cost,_this.x*20+50,_this.y*20+50);
        
      }
      //$LASTPOS=4000627;//user.SearchTest:627
      _this.r=_this.s.searchRoute({x: 0,y: 0},{x: 9,y: 9});
      //$LASTPOS=4000665;//user.SearchTest:665
      _this.p=1;
      //$LASTPOS=4000670;//user.SearchTest:670
      _it_32=Tonyu.iterator(_this.r,1);
      while(_it_32.next()) {
        _this.e=_it_32[0];
        
        //$LASTPOS=4000693;//user.SearchTest:693
        _this.x=_this.e.x*20+50;
        //$LASTPOS=4000710;//user.SearchTest:710
        _this.y=_this.e.y*20+50;
        //$LASTPOS=4000745;//user.SearchTest:745
        _this.updateEx(5);
        
      }
    },
    fiber$main :function _trc_SearchTest_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var _it_31;
      var _it_32;
      
      //$LASTPOS=4000042;//user.SearchTest:42
      _this.m=new Tonyu.classes.kernel.Matrix;
      //$LASTPOS=4000056;//user.SearchTest:56
      _this.m.fill(0,0,10,10,1);
      //$LASTPOS=4000077;//user.SearchTest:77
      //$LASTPOS=4000081;//user.SearchTest:81
      _this.i=0;for (; _this.i<30 ; _this.i++) {
        Tonyu.checkLoop();
        {
          //$LASTPOS=4000101;//user.SearchTest:101
          _this.m.set(_this.rnd(10),_this.rnd(10),0);
        }
      }
      //$LASTPOS=4000129;//user.SearchTest:129
      _this.m.set(9,9,1);
      //$LASTPOS=4000143;//user.SearchTest:143
      _this.m.set(0,0,1);
      //$LASTPOS=4000157;//user.SearchTest:157
      _this.s=new Tonyu.classes.user.MatrixSearcher(_this.m,{moveCost: (function anonymous_197(dst,src) {
        
        return dst.value;
      })});
      //$LASTPOS=4000411;//user.SearchTest:411
      "toste";
      //$LASTPOS=4000421;//user.SearchTest:421
      _this.cm=_this.s.searchCost({x: 0,y: 0});
      //$LASTPOS=4000449;//user.SearchTest:449
      Tonyu.globals.$panel.fillStyle="white";
      //$LASTPOS=4000488;//user.SearchTest:488
      _it_31=Tonyu.iterator(_this.cm.keysIterator(),3);
      while(_it_31.next()) {
        _this.x=_it_31[0];
        _this.y=_it_31[1];
        _this.c=_it_31[2];
        
        //$LASTPOS=4000568;//user.SearchTest:568
        Tonyu.globals.$panel.fillText(_this.c.cost,_this.x*20+50,_this.y*20+50);
        
      }
      //$LASTPOS=4000627;//user.SearchTest:627
      _this.r=_this.s.searchRoute({x: 0,y: 0},{x: 9,y: 9});
      //$LASTPOS=4000665;//user.SearchTest:665
      _this.p=1;
      
      _thread.enter(function _trc_SearchTest_ent_main(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=4000670;//user.SearchTest:670
            _it_32=Tonyu.iterator(_this.r,1);
          case 1:
            if (!(_it_32.next())) { __pc=3     ; break; }
            _this.e=_it_32[0];
            
            //$LASTPOS=4000693;//user.SearchTest:693
            _this.x=_this.e.x*20+50;
            //$LASTPOS=4000710;//user.SearchTest:710
            _this.y=_this.e.y*20+50;
            //$LASTPOS=4000745;//user.SearchTest:745
            _this.fiber$updateEx(_thread, 5);
            __pc=2;return;
          case 2:
            
            __pc=1;break;
          case 3     :
            
            _thread.exit(_this);return;
          }
        }
      });
    },
    test :function _trc_SearchTest_test(f) {
      "use strict";
      var _this=this;
      var a;
      var b;
      var _it_37;
      var _it_38;
      var d;
      
      //$LASTPOS=4000780;//user.SearchTest:780
      "toste";
      //$LASTPOS=4000793;//user.SearchTest:793
      _it_37=Tonyu.iterator(_this.c,2);
      while(_it_37.next()) {
        a=_it_37[0];
        b=_it_37[1];
        
        
        
      }
      ;
      
      //$LASTPOS=4000823;//user.SearchTest:823
      _it_38=Tonyu.iterator(_this.e,3);
      while(_it_38.next()) {
        d=_it_38[0];
        f=_it_38[1];
        _this.g=_it_38[2];
        
        
        
      }
      ;
      
      
    },
    fiber$test :function _trc_SearchTest_f_test(_thread,f) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var a;
      var b;
      var _it_37;
      var _it_38;
      var d;
      
      //$LASTPOS=4000780;//user.SearchTest:780
      "toste";
      //$LASTPOS=4000793;//user.SearchTest:793
      _it_37=Tonyu.iterator(_this.c,2);
      while(_it_37.next()) {
        a=_it_37[0];
        b=_it_37[1];
        
        
        
      }
      ;
      
      //$LASTPOS=4000823;//user.SearchTest:823
      _it_38=Tonyu.iterator(_this.e,3);
      while(_it_38.next()) {
        d=_it_38[0];
        f=_it_38[1];
        _this.g=_it_38[2];
        
        
        
      }
      ;
      
      
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"test":{"nowait":false}},"fields":{"m":{},"i":{},"s":{},"cm":{},"c":{},"r":{},"e":{},"g":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Unit',
  shortName: 'Unit',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: {
    main :function _trc_Unit_main() {
      "use strict";
      var _this=this;
      
      //$LASTPOS=5000105;//user.Unit:105
      Tonyu.globals.$mat.get(_this.x,_this.y).unit=_this;
      //$LASTPOS=5000130;//user.Unit:130
      _this.statuses=[{spd: 3,hp: 1,ap: 1},{spd: 1,hp: 10,ap: 2},{spd: 5,hp: 15,ap: 8},{spd: 4,hp: 2,ap: 1},{spd: 6,hp: 20,ap: 10},{spd: 2,hp: 2,ap: 6},{spd: 5,hp: 10,ap: 4},{spd: 1,hp: 5,ap: 1},{spd: 4,hp: 2,ap: 2},{spd: 1,hp: 2,ap: 3},{spd: 4,hp: 7,ap: 3},{spd: 5,hp: 7,ap: 7}];
      //$LASTPOS=5000502;//user.Unit:502
      _this.i=_this.p-Tonyu.globals.$pat_eto;
      //$LASTPOS=5000516;//user.Unit:516
      _this.side=(_this.i>=12);
      //$LASTPOS=5000530;//user.Unit:530
      _this.i=_this.i%12;
      //$LASTPOS=5000538;//user.Unit:538
      _this.status=_this.statuses[_this.i];
    },
    fiber$main :function _trc_Unit_f_main(_thread) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=5000105;//user.Unit:105
      Tonyu.globals.$mat.get(_this.x,_this.y).unit=_this;
      //$LASTPOS=5000130;//user.Unit:130
      _this.statuses=[{spd: 3,hp: 1,ap: 1},{spd: 1,hp: 10,ap: 2},{spd: 5,hp: 15,ap: 8},{spd: 4,hp: 2,ap: 1},{spd: 6,hp: 20,ap: 10},{spd: 2,hp: 2,ap: 6},{spd: 5,hp: 10,ap: 4},{spd: 1,hp: 5,ap: 1},{spd: 4,hp: 2,ap: 2},{spd: 1,hp: 2,ap: 3},{spd: 4,hp: 7,ap: 3},{spd: 5,hp: 7,ap: 7}];
      //$LASTPOS=5000502;//user.Unit:502
      _this.i=_this.p-Tonyu.globals.$pat_eto;
      //$LASTPOS=5000516;//user.Unit:516
      _this.side=(_this.i>=12);
      //$LASTPOS=5000530;//user.Unit:530
      _this.i=_this.i%12;
      //$LASTPOS=5000538;//user.Unit:538
      _this.status=_this.statuses[_this.i];
      
      _thread.retVal=_this;return;
    },
    draw :function _trc_Unit_draw(ctx) {
      "use strict";
      var _this=this;
      var sx;
      var sy;
      
      //$LASTPOS=5000017;//user.Unit:17
      sx = _this.x;
      sy = _this.y;
      
      //$LASTPOS=5000036;//user.Unit:36
      _this.x=_this.x*32+16;
      //$LASTPOS=5000051;//user.Unit:51
      _this.y=_this.y*32+16;
      //$LASTPOS=5000066;//user.Unit:66
      Tonyu.classes.kernel.Actor.prototype.draw.apply( _this, [ctx]);
      //$LASTPOS=5000087;//user.Unit:87
      _this.x=sx;
      //$LASTPOS=5000097;//user.Unit:97
      _this.y=sy;
    },
    moveTo :function _trc_Unit_moveTo(cm,gx,gy) {
      "use strict";
      var _this=this;
      var r;
      
      //$LASTPOS=5000710;//user.Unit:710
      r = cm.searchRoute({x: gx,y: gy});
      
      //$LASTPOS=5000747;//user.Unit:747
      if (r.length==0) {
        //$LASTPOS=5000774;//user.Unit:774
        _this.print("No move");
        return _this;
        
      }
      //$LASTPOS=5000818;//user.Unit:818
      _this.moving=true;
      //$LASTPOS=5000835;//user.Unit:835
      delete Tonyu.globals.$mat.get(_this.x,_this.y).unit;
      //$LASTPOS=5000866;//user.Unit:866
      _this.parallel(Tonyu.bindFunc(_this,_this.moveAction),r);
    },
    fiber$moveTo :function _trc_Unit_f_moveTo(_thread,cm,gx,gy) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var r;
      
      //$LASTPOS=5000710;//user.Unit:710
      r = cm.searchRoute({x: gx,y: gy});
      
      //$LASTPOS=5000747;//user.Unit:747
      if (r.length==0) {
        //$LASTPOS=5000774;//user.Unit:774
        _this.print("No move");
        _thread.retVal=_this;return;
        
        
      }
      //$LASTPOS=5000818;//user.Unit:818
      _this.moving=true;
      //$LASTPOS=5000835;//user.Unit:835
      delete Tonyu.globals.$mat.get(_this.x,_this.y).unit;
      //$LASTPOS=5000866;//user.Unit:866
      _this.parallel(Tonyu.bindFunc(_this,_this.moveAction),r);
      
      _thread.retVal=_this;return;
    },
    moveAction :function _trc_Unit_moveAction(route) {
      "use strict";
      var _this=this;
      var gx;
      var gy;
      var d;
      
      //$LASTPOS=5000917;//user.Unit:917
      while (route.length>1) {
        Tonyu.checkLoop();
        //$LASTPOS=5000949;//user.Unit:949
        _this.s=route.shift();
        //$LASTPOS=5000974;//user.Unit:974
        _this.x=_this.s.x;
        //$LASTPOS=5000989;//user.Unit:989
        _this.y=_this.s.y;
        //$LASTPOS=5001004;//user.Unit:1004
        _this.updateEx(2);
        
      }
      //$LASTPOS=5001027;//user.Unit:1027
      _this.s=route.shift();
      //$LASTPOS=5001048;//user.Unit:1048
      gx = _this.s.x;
      
      //$LASTPOS=5001064;//user.Unit:1064
      gy = _this.s.y;
      
      //$LASTPOS=5001080;//user.Unit:1080
      d = Tonyu.globals.$mat.get(gx,gy);
      
      //$LASTPOS=5001107;//user.Unit:1107
      if (d.unit) {
        //$LASTPOS=5001129;//user.Unit:1129
        //$LASTPOS=5001133;//user.Unit:1133
        _this.i=0;for (; _this.i<8 ; _this.i++) {
          Tonyu.checkLoop();
          {
            //$LASTPOS=5001160;//user.Unit:1160
            d.unit.rotation+=90;
            //$LASTPOS=5001193;//user.Unit:1193
            _this.update();
          }
        }
        
      } else {
        //$LASTPOS=5001234;//user.Unit:1234
        _this.x=gx;
        //$LASTPOS=5001239;//user.Unit:1239
        _this.y=gy;
        
      }
      //$LASTPOS=5001255;//user.Unit:1255
      Tonyu.globals.$mat.get(_this.x,_this.y).unit=_this;
      //$LASTPOS=5001284;//user.Unit:1284
      _this.moving=false;
    },
    fiber$moveAction :function _trc_Unit_f_moveAction(_thread,route) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      var gx;
      var gy;
      var d;
      
      
      _thread.enter(function _trc_Unit_ent_moveAction(_thread) {
        if (_thread.lastEx) __pc=_thread.catchPC;
        for(var __cnt=100 ; __cnt--;) {
          switch (__pc) {
          case 0:
            //$LASTPOS=5000917;//user.Unit:917
          case 1:
            if (!(route.length>1)) { __pc=3     ; break; }
            //$LASTPOS=5000949;//user.Unit:949
            _this.s=route.shift();
            //$LASTPOS=5000974;//user.Unit:974
            _this.x=_this.s.x;
            //$LASTPOS=5000989;//user.Unit:989
            _this.y=_this.s.y;
            //$LASTPOS=5001004;//user.Unit:1004
            _this.fiber$updateEx(_thread, 2);
            __pc=2;return;
          case 2:
            
            __pc=1;break;
          case 3     :
            
            //$LASTPOS=5001027;//user.Unit:1027
            _this.s=route.shift();
            //$LASTPOS=5001048;//user.Unit:1048
            gx = _this.s.x;
            
            //$LASTPOS=5001064;//user.Unit:1064
            gy = _this.s.y;
            
            //$LASTPOS=5001080;//user.Unit:1080
            d = Tonyu.globals.$mat.get(gx,gy);
            
            //$LASTPOS=5001107;//user.Unit:1107
            if (!(d.unit)) { __pc=8     ; break; }
            //$LASTPOS=5001129;//user.Unit:1129
            //$LASTPOS=5001133;//user.Unit:1133
            _this.i=0;
          case 4:
            if (!(_this.i<8)) { __pc=7     ; break; }
            //$LASTPOS=5001160;//user.Unit:1160
            d.unit.rotation+=90;
            //$LASTPOS=5001193;//user.Unit:1193
            _this.fiber$update(_thread);
            __pc=5;return;
          case 5:
            
          case 6     :
            _this.i++;
            __pc=4;break;
          case 7     :
            
            __pc=9     ;break;
          case 8     :
            {
              //$LASTPOS=5001234;//user.Unit:1234
              _this.x=gx;
              //$LASTPOS=5001239;//user.Unit:1239
              _this.y=gy;
            }
          case 9     :
            
            //$LASTPOS=5001255;//user.Unit:1255
            Tonyu.globals.$mat.get(_this.x,_this.y).unit=_this;
            //$LASTPOS=5001284;//user.Unit:1284
            _this.moving=false;
            _thread.exit(_this);return;
          }
        }
      });
    },
    moveCost :function _trc_Unit_moveCost(dst,src) {
      "use strict";
      var _this=this;
      
      //$LASTPOS=5001360;//user.Unit:1360
      if (! dst.value.unit) {
        return 1;
      }
      //$LASTPOS=5001436;//user.Unit:1436
      if (dst.value.unit.side===_this.side) {
        return false;
      } else {
        return _this.status.spd-src.cost;
      }
    },
    fiber$moveCost :function _trc_Unit_f_moveCost(_thread,dst,src) {
      "use strict";
      var _this=this;
      //var _arguments=Tonyu.A(arguments);
      var __pc=0;
      
      //$LASTPOS=5001360;//user.Unit:1360
      if (! dst.value.unit) {
        _thread.retVal=1;return;
        
      }
      //$LASTPOS=5001436;//user.Unit:1436
      if (dst.value.unit.side===_this.side) {
        _thread.retVal=false;return;
        
      } else {
        _thread.retVal=_this.status.spd-src.cost;return;
        
      }
      
      _thread.retVal=_this;return;
    },
    __dummy: false
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true},"moveTo":{"nowait":false},"moveAction":{"nowait":false},"moveCost":{"nowait":false}},"fields":{"statuses":{},"i":{},"side":{},"status":{},"moving":{},"s":{}}}
});

//# sourceMappingURL=concat.js.map